% LQR Design File
d2r=pi/180; r2d=180/pi;
load Kmix4.mat Kmix5 -ascii                         % Mixing Logic Matrix
[Av, Bv, Cv, Dv]= vehicle_sim_rb;                   % Simulation Model
[Ae, Be, Ce, De]= elevator;                         % Elevator Actuator
[At, Bt, Ct, Dt]= engine_tvc;                       % Engine TVC Actuator

% Longitudinal LQR Design
[Ad1, Bd1, Cd1, Dd1]= vehi_pitch_des;               % Load Pitch LQR Design Model
[Ai,Bi,Ci,Di]=linmod('Pitch_vehi_int');             % Augment LQR Design Model with integrator

Q= [1.e-7,1.e-5,1.e-7, 0.04,0.08, 0.004,0.008]*0.1; % Weight Matrices Q, R [1.e-7,0.001,0.0002, 0.4,0.8, 0.04,0.08]*0.1
Q=diag(Q);   
R= [5, 1]*0.02; R=diag(R);                          % R= [5, 1]*0.001;
[Kgp, s, e] = LQR(Ai,Bi,Q,R);                       % Pitch State-Feedback Matrix

% Lateral LQR Design
[Ad2, Bd2, Cd2, Dd2]= vehi_later_des;               % Load Lateral LQR Design Model
[Ai,Bi,Ci,Di]=linmod('Later_vehi_int');             % Augment LQR Design Model with integrator

Q= [50, 0.1, 1.e-5, 0.05, 0.5]; Q=diag(Q);          % Weight Matrices Q=[40,0.1,0.001,0.05,0.5];, R=[1,5]*0.12
R= [1, 8]*0.1; R=diag(R); 
[Kgl, s, e] = LQR(Ai,Bi,Q,R);                       % Lateral State-Feedback Matrix

save Kgp.mat Kgp -ascii
save Kgl.mat Kgl -ascii